import _extends from "@babel/runtime/helpers/esm/extends";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _setPrototypeOf from "@babel/runtime/helpers/esm/setPrototypeOf";
function _wrapRegExp() { _wrapRegExp = function _wrapRegExp(e, r) { return new BabelRegExp(e, void 0, r); }; var e = RegExp.prototype, r = new WeakMap(); function BabelRegExp(e, t, p) { var o = RegExp(e, t); return r.set(o, p || r.get(e)), _setPrototypeOf(o, BabelRegExp.prototype); } function buildGroups(e, t) { var p = r.get(t); return Object.keys(p).reduce(function (r, t) { var o = p[t]; if ("number" == typeof o) r[t] = e[o];else { for (var i = 0; void 0 === e[o[i]] && i + 1 < o.length;) i++; r[t] = e[o[i]]; } return r; }, Object.create(null)); } return _inherits(BabelRegExp, RegExp), BabelRegExp.prototype.exec = function (r) { var t = e.exec.call(this, r); if (t) { t.groups = buildGroups(t, this); var p = t.indices; p && (p.groups = buildGroups(p, this)); } return t; }, BabelRegExp.prototype[Symbol.replace] = function (t, p) { if ("string" == typeof p) { var o = r.get(this); return e[Symbol.replace].call(this, t, p.replace(/\$<([^>]+)>/g, function (e, r) { var t = o[r]; return "$" + (Array.isArray(t) ? t.join("$") : t); })); } if ("function" == typeof p) { var i = this; return e[Symbol.replace].call(this, t, function () { var e = arguments; return "object" != typeof e[e.length - 1] && (e = [].slice.call(e)).push(buildGroups(e, i)), p.apply(this, e); }); } return e[Symbol.replace].call(this, t, p); }, _wrapRegExp.apply(this, arguments); }
import { slugify } from '@s-ui/js/lib/string/slugify.js';
import DefaultAdapter from './adapters/default.js';
var INTERPOLATE_REGEX = /*#__PURE__*/_wrapRegExp(/%\[([\S\s]*?)\b\]([\S\s]*?)\[\1\]%/gi, {
  key: 1,
  children: 2
});
var Rosetta = /*#__PURE__*/function () {
  function Rosetta(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
      _ref$adapter = _ref.adapter,
      adapter = _ref$adapter === void 0 ? new DefaultAdapter() : _ref$adapter;
    this._culture = null;
    this._currency = null;
    this._languages = null;
    this._defaultNumberFormatOptions = null;
    this.translator = adapter;
  }
  var _proto = Rosetta.prototype;
  // Given a culture, it refreshes the translator with the current language.
  _proto._updateTranslator = function _updateTranslator(_ref2) {
    var culture = _ref2.culture;
    var _culture$split = culture.split('-'),
      locale = _culture$split[0];
    var translations = this._languages[culture];
    this.translator.locale = locale;
    this.translator.translations = translations;
  }

  /**
   * Add new languages or modify current ones.
   *
   * @param {String} culture The culture we want to update, takes current if left empty
   * @param {String} key Key in where to store the translation, if empty, will overwrite the language
   * @param {Object} translations Translations to be added
   */;
  _proto.addTranslations = function addTranslations(_ref3) {
    var culture = _ref3.culture,
      key = _ref3.key,
      translations = _ref3.translations;
    var newCulture = culture || this._culture;
    if (key) {
      this._languages[newCulture][key] = translations; // won't work for nested keys
    } else {
      this._languages[newCulture] = translations;
    }
    this._updateTranslator({
      culture: newCulture
    });
  }

  /**
   * Get all available translations for a key
   *
   * @param {String} key Key of the literal
   * @returns {Object} Object with cultures as key and literal as value
   */;
  _proto.getAllTranslations = function getAllTranslations(key) {
    var _this = this;
    if (!key) return {};
    return Object.fromEntries(Object.keys(this._languages).map(function (language) {
      return [language, key.split('.').reduce(function (level, newKey) {
        return level[newKey];
      }, _this._languages[language])];
    }));
  }

  // Translate.
  ;
  _proto.t = function t(key, values) {
    return this.translator.translate(key, values);
  }

  // Format number.
  ;
  _proto.n = function n(number, options, culture) {
    if (options === void 0) {
      options = {};
    }
    if (typeof number !== 'number') {
      throw new Error('i18n.n should receive a number.');
    }
    return typeof Intl !== 'undefined' ? new Intl.NumberFormat(culture || this._culture, _extends({}, this._defaultNumberFormatOptions, options)).format(number) : number;
  }

  // Format currency number.
  ;
  _proto.c = function c(number, minimumFractionDigits, culture) {
    if (minimumFractionDigits === void 0) {
      minimumFractionDigits = 0;
    }
    return this.n(number, {
      style: 'currency',
      currency: this._currency,
      minimumFractionDigits: minimumFractionDigits
    }, culture);
  }

  /**
   * Format minor types.
   *
   * @param {String} type The kind of value to be formatted:
   *                        - phone
   * @param {} value The value to be formatted
   * @param {Object} options Specific options for the specified type
   */;
  _proto.f = function f(type, value, options) {
    if (options === void 0) {
      options = {};
    }
    if (typeof type !== 'string') throw new Error('i18n.f should receive a string as a first argument');
    if (typeof value === 'undefined') throw new Error('i18n.f should receive any value as a second argument');
    switch (type) {
      case 'percentage':
        {
          var _options = options,
            _options$minimumFract = _options.minimumFractionDigits,
            minimumFractionDigits = _options$minimumFract === void 0 ? 0 : _options$minimumFract,
            _options$maximumFract = _options.maximumFractionDigits,
            maximumFractionDigits = _options$maximumFract === void 0 ? 2 : _options$maximumFract;
          return this.n(value / 100, {
            style: 'percent',
            minimumFractionDigits: minimumFractionDigits,
            maximumFractionDigits: maximumFractionDigits
          });
        }
      case 'phone':
        {
          var _options2 = options,
            _options2$separator = _options2.separator,
            separator = _options2$separator === void 0 ? ' ' : _options2$separator;
          return value.replace(/ /g, '') // reset all spaces
          .match(/.{1,3}/g) // group by chunks of 3
          .join(separator);
        }
    }
    throw new Error("Invalid type '" + type + "' passed to i18n.f");
  };
  _proto.formatPercentage = function formatPercentage(value, options) {
    return this.f('percentage', value, options);
  };
  _proto.formatPhone = function formatPhone(phoneNumber, options) {
    return this.f('phone', phoneNumber, options);
  };
  _proto.url = function url(urlPattern, allowQueryParams) {
    var _this2 = this;
    return urlPattern.split('/').map(function (token) {
      return token && slugify(_this2.t(token), allowQueryParams);
    }).join('/');
  }

  // Interpolate each text chunk, returning an array of all the transformed chunks.
  ;
  _proto.interpolate = function interpolate(key, values) {
    var _this3 = this;
    if (values === void 0) {
      values = {};
    }
    // Perform basic replace for static values
    var str = this.t(key, values);

    // Identify all the occurrences which are like: %[key]children[key]%, save {key, children} in a group for every match
    // Reset the state of the regex to start from the beginning
    INTERPOLATE_REGEX.lastIndex = 0;
    var matches = str.matchAll(INTERPOLATE_REGEX);
    var remaining = str;
    var result = Array.from(matches).flatMap(function (match) {
      var occurrence = match[0];
      var _match$groups = match.groups,
        key = _match$groups.key,
        children = _match$groups.children;

      // Handle nested matches
      // We need to reset the lastIndex to 0 to start the search from the beginning
      INTERPOLATE_REGEX.lastIndex = 0;
      if (INTERPOLATE_REGEX.test(children)) {
        children = _this3.interpolate(children, values);
      }
      var option = values[key];

      // Check if there is an available replacement for each match
      var replacement = typeof option === 'function' ? option({
        children: children
      }) : option;

      // Split the remaining string piece by the first occurence and keep the edges
      var _remaining$split = remaining.split(occurrence),
        beforeMatch = _remaining$split[0],
        afterMatch = _remaining$split.slice(1);
      remaining = afterMatch.join(occurrence);
      return [beforeMatch, replacement];
    });

    // Add potential last chunck of text.
    if (remaining.length > 0) result.push(remaining);

    // Clean falsy value and return the array of items
    return result.filter(Boolean);
  };
  return _createClass(Rosetta, [{
    key: "adapter",
    get: function get() {
      return this.translator;
    },
    set: function set(adapter) {
      this.translator = adapter;
    }
  }, {
    key: "culture",
    get: function get() {
      return this._culture;
    },
    set: function set(culture) {
      this._culture = culture;
      this._updateTranslator({
        culture: culture
      });
    }
  }, {
    key: "currency",
    get: function get() {
      return this._currency;
    },
    set: function set(currency) {
      this._currency = currency;
    }

    // According to Intl.NumberFormat options
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/NumberFormat/NumberFormat#options
  }, {
    key: "defaultNumberFormatOptions",
    set: function set(options) {
      this._defaultNumberFormatOptions = options;
    }
  }, {
    key: "locale",
    get: function get() {
      return this.translator.locale;
    }
  }, {
    key: "currencySymbol",
    get: function get() {
      var value = this.n(0, {
        style: 'currency',
        currency: this.currency,
        minimumFractionDigits: 0,
        maximumFractionDigits: 0
      });
      if (typeof value !== 'string') {
        return;
      }
      return value.replace(/\d/g, '').trim();
    }
  }, {
    key: "languages",
    get: function get() {
      return this._languages;
    },
    set: function set(languages) {
      this._languages = languages;
    }
  }]);
}();
export { Rosetta as default };